diff --git a/src/main/java/net/minecraft/core/block/piston/StickyPistonBaseBlock.java b/src/main/java/net/minecraft/core/block/piston/StickyPistonBaseBlock.java
new file mode 100644
index 000000000..4235a74b1
--- /dev/null
+++ b/src/main/java/net/minecraft/core/block/piston/StickyPistonBaseBlock.java
@@ -0,0 +1,79 @@
+package net.minecraft.core.block.piston;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.sound.SoundCategory;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.world.World;
+
+public class StickyPistonBaseBlock extends PistonBaseBlock {
+    public StickyPistonBaseBlock(String key, String namespaceId, int id, int maxPushedBlocks) {
+        super(key, namespaceId, id, maxPushedBlocks);
+    }
+
+    @Override
+    public void retractEvent(World world, int x, int y, int z, int data, Direction direction) {
+        BlockEntity blockEntity = world.getBlockEntity(x + direction.getOffsetX(), y + direction.getOffsetY(), z + direction.getOffsetZ());
+        if((blockEntity instanceof MovingPistonBlockEntity))
+        {
+            MovingPistonBlockEntity moving = ((MovingPistonBlockEntity) blockEntity);
+            if (!moving.isExtending()) {
+                ((MovingPistonBlockEntity)blockEntity).finalTick();
+            } else {
+                world.setBlock(x + direction.getOffsetX(), y + direction.getOffsetY(), z + direction.getOffsetZ(), 0);
+            }
+        }
+        world.setBlockAndMetadata(x, y, z, Blocks.PISTON_MOVING.id, direction.getId());
+        world.replaceBlockTileEntity(x, y, z, MovingPistonBlock.createTileEntity(id, direction.getId(), null, direction, false, true));
+        int x1 = x + direction.getOffsetX() * 2;
+        int y1 = y + direction.getOffsetY() * 2;
+        int z1 = z + direction.getOffsetZ() * 2;
+        int retractId = world.getBlockId(x1, y1, z1);
+        int retactMeta = world.getBlockMetadata(x1, y1, z1);
+        BlockEntity retractEntity = world.getBlockEntity(x1, y1, z1);
+        boolean pulledMoving = false;
+        if(retractId == Blocks.PISTON_MOVING.id)
+        {
+            BlockEntity blockEntity1 = world.getBlockEntity(x1, y1, z1);
+            if((blockEntity1 instanceof MovingPistonBlockEntity))
+            {
+                MovingPistonBlockEntity movingPistonBlock = (MovingPistonBlockEntity)blockEntity1;
+                if(movingPistonBlock.getDirection() == direction && movingPistonBlock.isExtending())
+                {
+                    movingPistonBlock.finalTick();
+                    retractId = movingPistonBlock.getMovedId();
+                    retactMeta = movingPistonBlock.getMovedData();
+                    retractEntity = movingPistonBlock.getMovedEntity();
+                    pulledMoving = true;
+                }
+            }
+        }
+        if(!pulledMoving && retractId > 0 &&
+            isPushable(retractId, world, x1, y1, z1, false) &&
+            (Block.blocksList[retractId].getPistonPushReaction(world, x1, y1, z1) == Material.PISTON_PUSHABLE || (Block.getBlock(retractId) instanceof PistonBaseBlock)))
+        {
+            if (!(retractEntity instanceof MovingPistonBlockEntity)) {
+                world.removeBlockTileEntity(x1, y1, z1);
+            }
+            world.setBlock(x1, y1, z1, 0);
+            x += direction.getOffsetX();
+            y += direction.getOffsetY();
+            z += direction.getOffsetZ();
+            world.setBlockAndMetadata(x, y, z, Blocks.PISTON_MOVING.id, retactMeta);
+            world.replaceBlockTileEntity(x, y, z, MovingPistonBlock.createTileEntity(retractId, retactMeta, retractEntity, direction, false, false));
+            world.notifyBlockChange(x1, y1, z1, 0);
+        } else
+        if(!pulledMoving)
+        {
+            world.setBlockWithNotify(x + direction.getOffsetX(), y + direction.getOffsetY(), z + direction.getOffsetZ(), 0);
+        }
+        world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double)x + 0.5D, (double)y + 0.5D, (double)z + 0.5D, "tile.piston.in", 0.5F, world.rand.nextFloat() * 0.15F + 0.6F);
+    }
+    @Override
+    public void createPistonHeadAt(World world, int x, int y, int z, int data, Direction direction) {
+        world.setBlockAndMetadata(x, y, z, Blocks.PISTON_MOVING.id,  PistonHeadBlock.setPistonType(PistonHeadBlock.TYPE_STICKY, direction.getId()));
+        world.replaceBlockTileEntity(x, y, z, MovingPistonBlock.createTileEntity(Blocks.PISTON_HEAD.id, PistonHeadBlock.setPistonType(PistonHeadBlock.TYPE_STICKY, direction.getId()), null, direction, true, false));
+    }
+}
diff --git a/src/main/java/net/minecraft/core/block/tag/BlockTags.java b/src/main/java/net/minecraft/core/block/tag/BlockTags.java
index aa2f3593b..2969d81d7 100644
--- a/src/main/java/net/minecraft/core/block/tag/BlockTags.java
+++ b/src/main/java/net/minecraft/core/block/tag/BlockTags.java
@@ -167,6 +167,14 @@ public abstract class BlockTags
      * Pigs will follow the player if they are holding this block.
      */
     public static Tag<Block> PIGS_FAVOURITE_BLOCK = Tag.of("pigs_favourite_block");
+    /**
+     * Nether mobs can spawn on this block {@link net.minecraft.core.entity.monster.ZombiePigMob ZombiePigMob}}.
+     */
+    public static Tag<Block> NETHER_MOBS_SPAWN = Tag.of("nether_mobs_spawn");
+    /**
+     * Will drop block when piston extends into it
+     */
+    public static Tag<Block> PISTON_CRUSHING = Tag.of("piston_crushing");
 
     public static List<Tag<Block>> TAG_LIST;
 
diff --git a/src/main/java/net/minecraft/core/entity/Entity.java b/src/main/java/net/minecraft/core/entity/Entity.java
index f72982319..e2e7171f4 100644
--- a/src/main/java/net/minecraft/core/entity/Entity.java
+++ b/src/main/java/net/minecraft/core/entity/Entity.java
@@ -59,6 +59,7 @@ public abstract class Entity
     public float xRot;
     public float yRotO;
     public float xRotO;
+    public float pushTime;
     public final AABB bb = AABB.getPermanentBB(0.0D, 0.0D, 0.0D, 0.0D, 0.0D, 0.0D);
     public boolean onGround = false;
     public boolean horizontalCollision;
@@ -234,6 +235,10 @@ public abstract class Entity
 
     public void baseTick()
     {
+        pushTime *= 0.98f;
+        if (pushTime < 0.001f){
+            pushTime = 0;
+        }
         if(vehicle != null && vehicle.isRemoved())
         {
             vehicle = null;
diff --git a/src/main/java/net/minecraft/core/entity/Mob.java b/src/main/java/net/minecraft/core/entity/Mob.java
index 8d83f3675..3a1a5db8c 100644
--- a/src/main/java/net/minecraft/core/entity/Mob.java
+++ b/src/main/java/net/minecraft/core/entity/Mob.java
@@ -884,6 +884,9 @@ public abstract class Mob extends Entity
             {
                 yd = 0.25D;
             }
+            if (!onGround){
+                movementScale = MathHelper.lerp(movementScale, 1f, pushTime);
+            }
             yd -= 0.08D;
             yd *= 0.98D;
             xd *= movementScale;
diff --git a/src/main/java/net/minecraft/core/entity/monster/ZombiePigMob.java b/src/main/java/net/minecraft/core/entity/monster/ZombiePigMob.java
index f738e2264..74a05b3bf 100644
--- a/src/main/java/net/minecraft/core/entity/monster/ZombiePigMob.java
+++ b/src/main/java/net/minecraft/core/entity/monster/ZombiePigMob.java
@@ -2,6 +2,8 @@ package net.minecraft.core.entity.monster;
 
 import net.minecraft.core.WeightedRandomLootObject;
 import net.minecraft.core.achievement.Achievements;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.Items;
@@ -65,7 +67,9 @@ public class ZombiePigMob extends ZombieMob
     	int y = MathHelper.floor(this.y);
     	int z = MathHelper.floor(this.z);
     	if(world.getBlockId(x, y, z) != 0) return false;
-    	int blockLight = world.getSavedLightValue(LightLayer.Block, x, y, z);
+        Block below = world.getBlock(x, y - 1, z);
+        if (!BlockTags.NETHER_MOBS_SPAWN.appliesTo(below)) return false;
+        int blockLight = world.getSavedLightValue(LightLayer.Block, x, y, z);
     	if(blockLight > 7) return false;
         return world.getDifficulty().canHostileMobsSpawn() && world.checkIfAABBIsClear(bb) && world.getCubes(this, bb).size() == 0 && !world.getIsAnyLiquid(bb);
     }
diff --git a/src/main/java/net/minecraft/core/entity/player/Player.java b/src/main/java/net/minecraft/core/entity/player/Player.java
index 0c3bf9202..cbec30952 100644
--- a/src/main/java/net/minecraft/core/entity/player/Player.java
+++ b/src/main/java/net/minecraft/core/entity/player/Player.java
@@ -199,7 +199,7 @@ public abstract class Player extends Mob
     @Override
 	public void tick()
     {
-        if (world.dimension == Dimension.nether) {
+        if (world.dimension == Dimension.NETHER) {
             if (y >= 260) {
                 addStat(Achievements.ENTER_OLDWORLD, 1);
             } else if (y >=128) {
@@ -1367,7 +1367,7 @@ public abstract class Player extends Mob
             if(j > 0)
             {
                 addStat(StatList.distanceSwumStat, j);
-                if (dimension == Dimension.nether.id) {
+                if (dimension == Dimension.NETHER.id) {
                     addStat(Achievements.SWIM_NETHER, 1);
                 }
             }
diff --git a/src/main/java/net/minecraft/core/entity/projectile/FireballProjectile.java b/src/main/java/net/minecraft/core/entity/projectile/FireballProjectile.java
index ca5a643eb..01b04f7db 100644
--- a/src/main/java/net/minecraft/core/entity/projectile/FireballProjectile.java
+++ b/src/main/java/net/minecraft/core/entity/projectile/FireballProjectile.java
@@ -17,9 +17,7 @@ import net.minecraft.core.util.helper.DamageType;
 
 public class FireballProjectile extends Projectile
 {
-    public double xPower = 0;
-    public double yPower = 0;
-    public double zPower = 0;
+    public static final double FIREBALL_SPEED = 1d;
 
     public FireballProjectile(World world)
     {
@@ -34,8 +32,7 @@ public class FireballProjectile extends Projectile
         setSize(1.0F, 1.0F);
         moveTo(x, y, z, yRot, xRot);
         setPos(x, y, z);
-        xd = yd = zd = 0.0D;
-        setAccel(vX, vY, vZ);
+        setVelocity(vX, vY, vZ, FIREBALL_SPEED);
     }
     public FireballProjectile(World world, Mob owner, double vX, double vY, double vZ)
     {
@@ -44,22 +41,21 @@ public class FireballProjectile extends Projectile
         moveTo(owner.x, owner.y, owner.z, owner.yRot, owner.xRot);
         setPos(x, y, z);
         heightOffset = 0.0F;
-        xd = yd = zd = 0.0D;
-        vX += random.nextGaussian() * 1.2D;
-        vY += random.nextGaussian() * 1.2D;
-        vZ += random.nextGaussian() * 1.2D;
-        setAccel(vX, vY, vZ);
+        vX += (random.nextGaussian() - random.nextGaussian()) * 0.8D;
+        vY += (random.nextGaussian()) * 0.4D;
+        vZ += (random.nextGaussian() - random.nextGaussian()) * 0.8D;
+        setVelocity(vX, vY, vZ, FIREBALL_SPEED);
     }
-    private void setAccel(double vX, double vY, double vZ){
+    private void setVelocity(double vX, double vY, double vZ, double speed){
         double velocity = MathHelper.sqrt(vX * vX + vY * vY + vZ * vZ);
         if (velocity != 0){
-            xPower = (vX / velocity) * 0.1D;
-            yPower = (vY / velocity) * 0.1D;
-            zPower = (vZ / velocity) * 0.1D;
+            xd = (vX / velocity) * speed;
+            yd = (vY / velocity) * speed;
+            zd = (vZ / velocity) * speed;
         } else {
-            xPower = 0;
-            yPower = 0;
-            zPower = 0;
+            xd = 0;
+            yd = 0;
+            zd = 0;
         }
     }
 
@@ -100,9 +96,6 @@ public class FireballProjectile extends Projectile
     }
     public void afterTick(){
         super.afterTick();
-        xd += xPower;
-        yd += yPower;
-        zd += zPower;
         world.spawnParticle("largesmoke", x, y, z, 0.0D, 0.0D, 0.0D, 0);
     }
 
@@ -115,7 +108,7 @@ public class FireballProjectile extends Projectile
     @Override
 	public float getPickRadius()
     {
-        return 1.0F;
+        return 1f;
     }
     @Override
     public boolean hurt(Entity entity, int i, DamageType type)
@@ -129,12 +122,7 @@ public class FireballProjectile extends Projectile
             }
             if(lookAngle != null)
             {
-                xd = lookAngle.x;
-                yd = lookAngle.y;
-                zd = lookAngle.z;
-                xPower = xd * 0.1D;
-                yPower = yd * 0.1D;
-                zPower = zd * 0.1D;
+                setVelocity(lookAngle.x, lookAngle.y, lookAngle.z, FIREBALL_SPEED);
             }
             return true;
         } else
diff --git a/src/main/java/net/minecraft/core/entity/vehicle/MinecartEntity.java b/src/main/java/net/minecraft/core/entity/vehicle/MinecartEntity.java
index 01e91ef0c..728d6f1c1 100644
--- a/src/main/java/net/minecraft/core/entity/vehicle/MinecartEntity.java
+++ b/src/main/java/net/minecraft/core/entity/vehicle/MinecartEntity.java
@@ -19,7 +19,6 @@ import net.minecraft.core.player.gamemode.Gamemode;
 import net.minecraft.core.player.inventory.container.Container;
 import net.minecraft.core.player.inventory.InventorySorter;
 import net.minecraft.core.util.helper.DamageType;
-import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.World;
@@ -31,6 +30,9 @@ public class MinecartEntity extends Entity implements Container {
     public static final int PASSENGER_CART = 0;
     public static final int CHEST_CART = 1;
     public static final int FURNACE_CART = 2;
+
+    public static final int TYPE_MASK_COLOR = 0b1111_0000;
+    public static final int TYPE_MASK_PAINTED_CHEST = 0b0000_0001;
     // 10 x 2 x 3 table of something
     private static final int[][][] EXITS = {
         {
@@ -195,7 +197,11 @@ public class MinecartEntity extends Entity implements Container {
                 spawnAtLocation(Items.MINECART.id, 1, 0.0F);
                 switch (this.type){
                     case CHEST_CART:
-                        spawnAtLocation(Blocks.CHEST_PLANKS_OAK.id, 1, 0.0F);
+                        if ((typeMeta & TYPE_MASK_PAINTED_CHEST) != 0) {
+                            spawnAtLocation(new ItemStack(Blocks.CHEST_PLANKS_OAK_PAINTED, 1, typeMeta & TYPE_MASK_COLOR), 0.0F);
+                        } else {
+                            spawnAtLocation(Blocks.CHEST_PLANKS_OAK.id, 1, 0.0F);
+                        }
                         break;
                     case FURNACE_CART:
                         spawnAtLocation(Blocks.FURNACE_STONE_IDLE.id, 1, 0.0F);
@@ -702,9 +708,9 @@ public class MinecartEntity extends Entity implements Container {
                         ChestBlockEntity chest = (ChestBlockEntity) carriedBlock.entity;
                         this.type = CHEST_CART;
                         if (carriedBlock.block == Blocks.CHEST_PLANKS_OAK_PAINTED) {
-                            this.typeMeta = carriedBlock.metadata & 0b1111_0000 | 0b0000_0001;
+                            this.typeMeta = carriedBlock.metadata & TYPE_MASK_COLOR | TYPE_MASK_PAINTED_CHEST;
                         } else {
-                            this.typeMeta = carriedBlock.metadata & 0b1111_0000;
+                            this.typeMeta = carriedBlock.metadata & TYPE_MASK_COLOR;
                         }
                         for (int i = 0; i < this.getContainerSize(); i++) {
                             this.setItem(i, chest.getItem(i));
@@ -731,12 +737,12 @@ public class MinecartEntity extends Entity implements Container {
                         }
                         blockEntity.worldObj = null;
                         Block block;
-                        if ((typeMeta & 0b0000_0001) != 0) {
+                        if ((typeMeta & TYPE_MASK_PAINTED_CHEST) != 0) {
                             block = Blocks.CHEST_PLANKS_OAK_PAINTED;
                         } else {
                             block = Blocks.CHEST_PLANKS_OAK;
                         }
-                        blockEntity.carriedBlock = blockEntity.getCarriedEntry(world, player, block, typeMeta & 0b1111_0000);
+                        blockEntity.carriedBlock = blockEntity.getCarriedEntry(world, player, block, typeMeta & TYPE_MASK_COLOR);
                         player.setHeldObject(blockEntity.carriedBlock);
                         this.type = PASSENGER_CART;
                         this.typeMeta = 0;
diff --git a/src/main/java/net/minecraft/core/item/BucketItem.java b/src/main/java/net/minecraft/core/item/BucketItem.java
index e4c1579ec..5d92fb0fa 100644
--- a/src/main/java/net/minecraft/core/item/BucketItem.java
+++ b/src/main/java/net/minecraft/core/item/BucketItem.java
@@ -87,7 +87,7 @@ public class BucketItem extends Item
 		}
 		
 		if(world.isAirBlock(x, y, z) || !world.getBlockMaterial(x, y, z).isSolid()) {
-			if(world.dimension == Dimension.nether && idToPlace == Blocks.FLUID_WATER_FLOWING.id) {
+			if(world.dimension == Dimension.NETHER && idToPlace == Blocks.FLUID_WATER_FLOWING.id) {
 				world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, z + 0.5, y + 0.5, x + 0.5, "random.fizz", 0.5F, 2.6F + (world.rand.nextFloat() - world.rand.nextFloat()) * 0.8F);
 				for (int l = 0; l < 8; l++) {
 					world.spawnParticle("largesmoke", x + Math.random(), y + Math.random(), z + Math.random(), 0.0D, 0.0D, 0.0D, 0);
diff --git a/src/main/java/net/minecraft/core/net/entity/entries/FireballNetEntry.java b/src/main/java/net/minecraft/core/net/entity/entries/FireballNetEntry.java
index 1efec894c..e1b905560 100644
--- a/src/main/java/net/minecraft/core/net/entity/entries/FireballNetEntry.java
+++ b/src/main/java/net/minecraft/core/net/entity/entries/FireballNetEntry.java
@@ -18,17 +18,17 @@ public class FireballNetEntry implements IVehicleEntry<FireballProjectile>, ITra
 
     @Override
     public int getTrackingDistance() {
-        return 64;
+        return 128;
     }
 
     @Override
     public int getPacketDelay() {
-        return 10;
+        return 1;
     }
 
     @Override
     public boolean sendMotionUpdates() {
-        return false;
+        return true;
     }
 
     @Override
@@ -43,6 +43,6 @@ public class FireballNetEntry implements IVehicleEntry<FireballProjectile>, ITra
 
     @Override
     public AddEntityPacket getSpawnPacket(EntityTrackerEntry tracker, FireballProjectile trackedObject) {
-        return new AddEntityPacket(trackedObject, -1, -1, trackedObject.xPower, trackedObject.yPower, trackedObject.zPower);
+        return new AddEntityPacket(trackedObject, -1, -1, trackedObject.xd, trackedObject.yd, trackedObject.zd);
     }
 }
diff --git a/src/main/java/net/minecraft/core/world/Dimension.java b/src/main/java/net/minecraft/core/world/Dimension.java
index 633b815a6..5add6e428 100644
--- a/src/main/java/net/minecraft/core/world/Dimension.java
+++ b/src/main/java/net/minecraft/core/world/Dimension.java
@@ -7,6 +7,7 @@ import net.minecraft.core.world.type.WorldType;
 import net.minecraft.core.world.type.WorldTypes;
 
 import java.util.Collections;
+import java.util.Date;
 import java.util.HashMap;
 import java.util.Map;
 
@@ -74,9 +75,9 @@ public class Dimension
 
 	private static final Map<Integer, Dimension> dimensionList = new HashMap<>();
 
-	public static Dimension overworld;
-	public static Dimension nether;
-	public static Dimension paradise;
+	public static Dimension OVERWORLD;
+	public static Dimension NETHER;
+	public static Dimension PARADISE;
 
 	public static Map<Integer, Dimension> getDimensionList()
 	{
@@ -95,12 +96,12 @@ public class Dimension
 		dimensionList.put(id, dimension);
 	}
 	public static void init(){
-		overworld = new Dimension("overworld", null, 1.0f, -1, WorldTypes.OVERWORLD_DEFAULT);
-		nether = new Dimension("nether", overworld, 0.125f, Blocks.PORTAL_NETHER.id, WorldTypes.NETHER_DEFAULT);
-		paradise = new Dimension("paradise", overworld, 8.0f, Blocks.PORTAL_PARADISE.id, WorldTypes.PARADISE_DEFAULT);
+		OVERWORLD = new Dimension("overworld", null, 1.0f, -1, WorldTypes.OVERWORLD_DEFAULT);
+		NETHER = new Dimension("nether", OVERWORLD, 0.125f, Blocks.PORTAL_NETHER.id, WorldTypes.NETHER_DEFAULT);
+		PARADISE = new Dimension("paradise", OVERWORLD, 8.0f, Blocks.PORTAL_PARADISE.id, WorldTypes.PARADISE_DEFAULT);
 
-		registerDimension(0, overworld);
-		registerDimension(1, nether);
-		registerDimension(2, paradise);
+		registerDimension(0, OVERWORLD);
+		registerDimension(1, NETHER);
+		registerDimension(2, PARADISE);
 	}
 }
diff --git a/src/main/java/net/minecraft/core/world/Explosion.java b/src/main/java/net/minecraft/core/world/Explosion.java
index d0c3c689b..60423c2fc 100644
--- a/src/main/java/net/minecraft/core/world/Explosion.java
+++ b/src/main/java/net/minecraft/core/world/Explosion.java
@@ -168,6 +168,8 @@ public class Explosion {
                 entity.xd += d6 * d14;
                 entity.yd += d8 * d14;
                 entity.zd += d10 * d14;
+
+                entity.pushTime = 1f;
             }
         }
 	}
diff --git a/src/main/java/net/minecraft/core/world/World.java b/src/main/java/net/minecraft/core/world/World.java
index d3bebcc0a..a15af5e56 100644
--- a/src/main/java/net/minecraft/core/world/World.java
+++ b/src/main/java/net/minecraft/core/world/World.java
@@ -300,7 +300,7 @@ public class World implements WorldSource {
 
     // Used for the model viewer
     public World(){
-        this.dimension = Dimension.overworld;
+        this.dimension = Dimension.OVERWORLD;
         this.saveHandler = null;
         levelData = new LevelData(0, "modelviewer");
         this.worldType = WorldTypes.DEBUG;
@@ -1806,7 +1806,6 @@ public class World implements WorldSource {
             }
         }
     }
-
     public void updateEntities()
     {
         for(int i = 0; i < weatherEffects.size(); i++)
@@ -1877,7 +1876,7 @@ public class World implements WorldSource {
                 loadedBlockEntityList.remove(i);
                 Chunk chunk = getChunkFromChunkCoords(Math.floorDiv(blockEntity.x, Chunk.CHUNK_SIZE_X), Math.floorDiv(blockEntity.z, Chunk.CHUNK_SIZE_Z));
                 if (chunk != null) {
-                    chunk.removeBlockEntity(blockEntity.x & (Chunk.CHUNK_SIZE_X - 1), blockEntity.y, blockEntity.z & (Chunk.CHUNK_SIZE_Z - 1));
+                    chunk.removeBlockEntity(blockEntity);
                 }
             }
         }
@@ -2260,23 +2259,23 @@ public class World implements WorldSource {
         }
     }
 
-    public void setBlockTileEntity(int i, int j, int k, BlockEntity blockEntity)
+    public void setBlockTileEntity(int x, int y, int z, BlockEntity blockEntity)
     {
         if(!blockEntity.isInvalid())
         {
-            Chunk chunk = getChunkFromChunkCoords(Math.floorDiv(i, Chunk.CHUNK_SIZE_X), Math.floorDiv(k, Chunk.CHUNK_SIZE_Z));
+            Chunk chunk = getChunkFromChunkCoords(Math.floorDiv(x, Chunk.CHUNK_SIZE_X), Math.floorDiv(z, Chunk.CHUNK_SIZE_Z));
             if(chunk != null)
             {
-                if (chunk.setBlockEntity(i & (Chunk.CHUNK_SIZE_X - 1), j, k & (Chunk.CHUNK_SIZE_Z - 1), blockEntity) && !loadedBlockEntityList.contains(blockEntity)) {
+                if (chunk.setBlockEntity(x & (Chunk.CHUNK_SIZE_X - 1), y, z & (Chunk.CHUNK_SIZE_Z - 1), blockEntity) && !loadedBlockEntityList.contains(blockEntity)) {
                     loadedBlockEntityList.add(blockEntity);
                 }
             }
         }
     }
 
-    public void removeBlockTileEntity(int i, int j, int k)
+    public void removeBlockTileEntity(int x, int y, int z)
     {
-        BlockEntity blockEntity = getBlockEntity(i, j, k);
+        BlockEntity blockEntity = getBlockEntity(x, y, z);
 
         if(blockEntity != null && updatingBlockEntities)
         {
@@ -2287,17 +2286,17 @@ public class World implements WorldSource {
             {
                 loadedBlockEntityList.remove(blockEntity);
             }
-            Chunk chunk = getChunkFromChunkCoords(Math.floorDiv(i, Chunk.CHUNK_SIZE_X), Math.floorDiv(k, Chunk.CHUNK_SIZE_Z));
+            Chunk chunk = getChunkFromChunkCoords(Math.floorDiv(x, Chunk.CHUNK_SIZE_X), Math.floorDiv(z, Chunk.CHUNK_SIZE_Z));
             if(chunk != null)
             {
-                chunk.removeBlockEntity(i & (Chunk.CHUNK_SIZE_X - 1), j, k & (Chunk.CHUNK_SIZE_Z - 1));
+                chunk.removeBlockEntity(blockEntity);
             }
         }
     }
 
-    public void replaceBlockTileEntity(int i, int j, int k, BlockEntity tileentity) {
-        removeBlockTileEntity(i, j, k);
-        setBlockTileEntity(i, j, k, tileentity);
+    public void replaceBlockTileEntity(int x, int y, int z, BlockEntity blockEntity) {
+        removeBlockTileEntity(x, y, z);
+        setBlockTileEntity(x, y, z, blockEntity);
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/core/world/chunk/Chunk.java b/src/main/java/net/minecraft/core/world/chunk/Chunk.java
index 1427443b7..3d86cbb7f 100644
--- a/src/main/java/net/minecraft/core/world/chunk/Chunk.java
+++ b/src/main/java/net/minecraft/core/world/chunk/Chunk.java
@@ -529,7 +529,9 @@ public class Chunk
         {
             blockEntity.validate();
             BlockEntity previous = blockEntityMap.put(chunkposition, blockEntity);
-            world.loadedBlockEntityList.remove(previous);
+            if (previous != null) {
+                previous.invalidate();
+            }
             return true;
         }
         return false;
@@ -548,6 +550,13 @@ public class Chunk
         }
     }
 
+    public void removeBlockEntity(BlockEntity blockEntity) {
+        if (isLoaded && blockEntity != null && blockEntityMap.containsValue(blockEntity)) {
+            blockEntityMap.remove(new ChunkPosition(blockEntity.x & (Chunk.CHUNK_SIZE_X - 1), blockEntity.y, blockEntity.z & (Chunk.CHUNK_SIZE_Z - 1)));
+            blockEntity.invalidate();
+        }
+    }
+
     public void onLoad()
     {
         isLoaded = true;
diff --git a/src/main/java/net/minecraft/core/world/save/SaveFile.java b/src/main/java/net/minecraft/core/world/save/SaveFile.java
index 7ca8f2768..25407b560 100644
--- a/src/main/java/net/minecraft/core/world/save/SaveFile.java
+++ b/src/main/java/net/minecraft/core/world/save/SaveFile.java
@@ -3,13 +3,14 @@ package net.minecraft.core.world.save;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
+import java.util.Map;
 import java.util.Objects;
 
 public class SaveFile
     implements Comparable<SaveFile>
 {
 
-    public SaveFile(@NotNull String fileName, @NotNull String displayName, @Nullable LevelData levelData, DimensionData @NotNull [] dimensionData, long lastTimePlayed, long sizeOnDisk, boolean needsConversion)
+    public SaveFile(@NotNull String fileName, @NotNull String displayName, @Nullable LevelData levelData, @NotNull Map<Integer, DimensionData> dimensionData, long lastTimePlayed, long sizeOnDisk, boolean needsConversion)
     {
         this.fileName = Objects.requireNonNull(fileName);
         this.displayName = Objects.requireNonNull(displayName);
@@ -19,7 +20,7 @@ public class SaveFile
         this.levelData = levelData;
         this.dimensionData = Objects.requireNonNull(dimensionData);
 
-        this.corrupted = levelData == null || (!needsConversion && dimensionData[0] == null);
+        this.corrupted = levelData == null || (!needsConversion && dimensionData.get(0) == null);
     }
 
     public String getFileName()
@@ -36,8 +37,8 @@ public class SaveFile
     {
     	return levelData;
     }
-    @Nullable
-    public DimensionData[] getDimensionData()
+    @NotNull
+    public Map<Integer, DimensionData> getDimensionData()
     {
         return dimensionData;
     }
@@ -87,8 +88,7 @@ public class SaveFile
     private final String displayName;
     @Nullable
     private final LevelData levelData;
-    @NotNull
-    private final DimensionData[] dimensionData;
+    private final @NotNull Map<Integer, DimensionData> dimensionData;
     private final long lastTimePlayed;
     private final long sizeOnDisk;
     private final boolean needsConversion;
diff --git a/src/main/java/net/minecraft/core/world/save/SaveFormatBase.java b/src/main/java/net/minecraft/core/world/save/SaveFormatBase.java
index bad31a653..b5039285a 100644
--- a/src/main/java/net/minecraft/core/world/save/SaveFormatBase.java
+++ b/src/main/java/net/minecraft/core/world/save/SaveFormatBase.java
@@ -11,7 +11,9 @@ import org.slf4j.Logger;
 import java.io.File;
 import java.nio.file.Files;
 import java.util.ArrayList;
+import java.util.HashMap;
 import java.util.List;
+import java.util.Map;
 
 public abstract class SaveFormatBase
     implements ISaveFormat
@@ -145,13 +147,12 @@ public abstract class SaveFormatBase
                 String worldName;
                 long lastTimePlayed;
                 long size;
-                DimensionData[] dimensionData;
+                Map<Integer, DimensionData> dimensionData = new HashMap<>();
                 boolean needsConversion = false;
                 if (levelData == null) {
                     worldName = I18n.getInstance().translateKey("save.data.missing.data");
                     lastTimePlayed = System.currentTimeMillis();
                     size = -1;
-                    dimensionData = new DimensionData[Dimension.getDimensionList().size()];
                 } else {
                     lastTimePlayed = levelData.getLastTimePlayed();
                     size = levelData.getSizeOnDisk();
@@ -161,10 +162,9 @@ public abstract class SaveFormatBase
                     {
                         worldName = worldDirName;
                     }
-                    dimensionData = new DimensionData[Dimension.getDimensionList().size()];
                     for (Dimension dimension : Dimension.getDimensionList().values())
                     {
-                        dimensionData[dimension.id] = getDimensionData(worldDirName, dimension.id);
+                        dimensionData.put(dimension.id, getDimensionData(worldDirName, dimension.id));
                     }
                 }
                 saveFileList.add(new SaveFile(worldDirName, worldName, levelData, dimensionData, lastTimePlayed, size, needsConversion));
diff --git a/src/main/java/net/minecraft/core/world/save/legacy/SaveFormatLegacy.java b/src/main/java/net/minecraft/core/world/save/legacy/SaveFormatLegacy.java
index 9a22fee98..7210eed68 100644
--- a/src/main/java/net/minecraft/core/world/save/legacy/SaveFormatLegacy.java
+++ b/src/main/java/net/minecraft/core/world/save/legacy/SaveFormatLegacy.java
@@ -33,7 +33,7 @@ public class SaveFormatLegacy
     {
         File worldDir = new File(savesDir, worldDirName);
 
-        if (dimension == Dimension.overworld)
+        if (dimension == Dimension.OVERWORLD)
         {
             return worldDir;
         }
diff --git a/src/main/java/net/minecraft/core/world/save/mcregion/SaveFormat19132.java b/src/main/java/net/minecraft/core/world/save/mcregion/SaveFormat19132.java
index db1675d91..1573c62da 100644
--- a/src/main/java/net/minecraft/core/world/save/mcregion/SaveFormat19132.java
+++ b/src/main/java/net/minecraft/core/world/save/mcregion/SaveFormat19132.java
@@ -38,7 +38,7 @@ public class SaveFormat19132
     {
         File worldDir = new File(savesDir, worldDirName);
 
-        if (dimension == Dimension.overworld)
+        if (dimension == Dimension.OVERWORLD)
         {
             return worldDir;
         }
